<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: HFSMBase&lt; WeaponStateBase, WeaponEventBase, WeaponActionBase, WeaponGuardBase &gt; Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.18.155069</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#pri-static-attribs">Static Private Attributes</a>  </div>
  <div class="headertitle"><div class="title">HFSMBase&lt; WeaponStateBase, WeaponEventBase, WeaponActionBase, WeaponGuardBase &gt; Class Reference</div></div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-methods" name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a0a6d548e39e2404b64acd5411b09caba"><td class="memItemLeft" align="right" valign="top">protected void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a0a6d548e39e2404b64acd5411b09caba">SetInternalID</a> (<a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> state)</td></tr>
<tr class="memdesc:a0a6d548e39e2404b64acd5411b09caba"><td class="mdescLeft">&#160;</td><td class="mdescRight">unique list of states in this machine (automation of save/load)  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a0a6d548e39e2404b64acd5411b09caba">More...</a><br /></td></tr>
<tr class="separator:a0a6d548e39e2404b64acd5411b09caba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a39c6c17bbe295f0b340e09b9aa2e0370"><td class="memItemLeft" align="right" valign="top">override void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a39c6c17bbe295f0b340e09b9aa2e0370">AddTransition</a> (<a class="el" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt; t)</td></tr>
<tr class="memdesc:a39c6c17bbe295f0b340e09b9aa2e0370"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds transition into transition table As a side effect registers the state(s) into m_UniqueStates  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a39c6c17bbe295f0b340e09b9aa2e0370">More...</a><br /></td></tr>
<tr class="separator:a39c6c17bbe295f0b340e09b9aa2e0370"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a81eb0c468b2fe3a4fe62441b3f47f8e0"><td class="memItemLeft" align="right" valign="top">override protected <a class="el" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a81eb0c468b2fe3a4fe62441b3f47f8e0">ProcessLocalTransition</a> (<a class="el" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt; t, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e)</td></tr>
<tr class="separator:a81eb0c468b2fe3a4fe62441b3f47f8e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a121dc2e835caf00f21e1150f7e03983b"><td class="memItemLeft" align="right" valign="top">override <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a121dc2e835caf00f21e1150f7e03983b">ProcessAbortEvent</a> (<a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e, out <a class="el" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a> result)</td></tr>
<tr class="separator:a121dc2e835caf00f21e1150f7e03983b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff48945f386ea092ea49ec243f5f1796"><td class="memItemLeft" align="right" valign="top">override protected <a class="el" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#aff48945f386ea092ea49ec243f5f1796">ProcessAbortTransition</a> (<a class="el" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt; t, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e)</td></tr>
<tr class="separator:aff48945f386ea092ea49ec243f5f1796"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbad6d95dace65d55f3737d8d773a806"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#adbad6d95dace65d55f3737d8d773a806">FindStateForInternalID</a> (<a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> id)</td></tr>
<tr class="memdesc:adbad6d95dace65d55f3737d8d773a806"><td class="mdescLeft">&#160;</td><td class="mdescRight">retrieve base state that matches given internal id  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#adbad6d95dace65d55f3737d8d773a806">More...</a><br /></td></tr>
<tr class="separator:adbad6d95dace65d55f3737d8d773a806"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5e58979a0005f2a048074474b41a9e2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ac5e58979a0005f2a048074474b41a9e2">FindStableStateForID</a> (<a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> id)</td></tr>
<tr class="memdesc:ac5e58979a0005f2a048074474b41a9e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">load from database - reverse lookup for state from saved id  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ac5e58979a0005f2a048074474b41a9e2">More...</a><br /></td></tr>
<tr class="separator:ac5e58979a0005f2a048074474b41a9e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3033531843a746d7181e7e167df5f6dc"><td class="memItemLeft" align="right" valign="top">protected <a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a3033531843a746d7181e7e167df5f6dc">LoadAndSetCurrentFSMState</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#a4ff67286551fc6c18504752a277c8bc1">ParamsReadContext</a> ctx, <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> version)</td></tr>
<tr class="separator:a3033531843a746d7181e7e167df5f6dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7764df4dff05076f74167b0ce50bdc43"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a7764df4dff05076f74167b0ce50bdc43">LoadCurrentFSMState</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#a4ff67286551fc6c18504752a277c8bc1">ParamsReadContext</a> ctx, <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> version)</td></tr>
<tr class="memdesc:a7764df4dff05076f74167b0ce50bdc43"><td class="mdescLeft">&#160;</td><td class="mdescRight">load current state of fsm  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a7764df4dff05076f74167b0ce50bdc43">More...</a><br /></td></tr>
<tr class="separator:a7764df4dff05076f74167b0ce50bdc43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a007b947e912d1e84eca73d5c8bd45901"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a007b947e912d1e84eca73d5c8bd45901">LoadCurrentUnstableFSMState</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a> ctx, <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> version)</td></tr>
<tr class="separator:a007b947e912d1e84eca73d5c8bd45901"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a547396c4dcbe758656386371d79b4163"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a547396c4dcbe758656386371d79b4163">SaveCurrentFSMState</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a> ctx)</td></tr>
<tr class="memdesc:a547396c4dcbe758656386371d79b4163"><td class="mdescLeft">&#160;</td><td class="mdescRight">save current state of fsm  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a547396c4dcbe758656386371d79b4163">More...</a><br /></td></tr>
<tr class="separator:a547396c4dcbe758656386371d79b4163"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b9c22cee987009d8b509d91d72371a1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a2b9c22cee987009d8b509d91d72371a1">SaveCurrentUnstableFSMState</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a> ctx)</td></tr>
<tr class="separator:a2b9c22cee987009d8b509d91d72371a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7d3938684ce733ea27a97ab89ef2ed9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ae7d3938684ce733ea27a97ab89ef2ed9">ValidateAndRepair</a> ()</td></tr>
<tr class="memdesc:ae7d3938684ce733ea27a97ab89ef2ed9"><td class="mdescLeft">&#160;</td><td class="mdescRight">validate the state of the gun and repair if mismatch  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ae7d3938684ce733ea27a97ab89ef2ed9">More...</a><br /></td></tr>
<tr class="separator:ae7d3938684ce733ea27a97ab89ef2ed9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47c5052caf7a6925483e8748a3503a07"><td class="memItemLeft" align="right" valign="top">protected <a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a47c5052caf7a6925483e8748a3503a07">Internal_ValidateAndRepair</a> ()</td></tr>
<tr class="memdesc:a47c5052caf7a6925483e8748a3503a07"><td class="mdescLeft">&#160;</td><td class="mdescRight">validate the state of the gun and repair if mismatch  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a47c5052caf7a6925483e8748a3503a07">More...</a><br /></td></tr>
<tr class="separator:a47c5052caf7a6925483e8748a3503a07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e24e0c05a0b315f2b16c1feb4c9d3f4"><td class="memItemLeft" align="right" valign="top">protected <a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a8e24e0c05a0b315f2b16c1feb4c9d3f4">ValidateAndRepairHelper</a> (<a class="el" href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a> weapon, <a class="el" href="../../d5/da2/group___strings.html#d5/d92/classstring">string</a> <a class="el" href="../../db/d3f/_plugin_day_z_infected_debug_8c.html#a8ccf841cb59e451791bcb2e1ac4f1edc">name</a>, <a class="el" href="../../d9/db9/classbool.html">bool</a> stateCondition, <a class="el" href="../../d9/db9/classbool.html">bool</a> gunCondition, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e1, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e2, out <a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a> state)</td></tr>
<tr class="separator:a8e24e0c05a0b315f2b16c1feb4c9d3f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cb72d561154285bebee4d88f7041b5d"><td class="memItemLeft" align="right" valign="top">protected void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a6cb72d561154285bebee4d88f7041b5d">OnFailThresholdBreached</a> (<a class="el" href="../../db/de5/class_weapon.html">Weapon</a> weapon, <a class="el" href="../../d5/da2/group___strings.html#d5/d92/classstring">string</a> <a class="el" href="../../db/d3f/_plugin_day_z_infected_debug_8c.html#a8ccf841cb59e451791bcb2e1ac4f1edc">name</a>, <a class="el" href="../../d9/db9/classbool.html">bool</a> stateCondition, <a class="el" href="../../d9/db9/classbool.html">bool</a> gunCondition)</td></tr>
<tr class="separator:a6cb72d561154285bebee4d88f7041b5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d473a6c6e1925e23503d6f1ed8a3557"><td class="memItemLeft" align="right" valign="top">protected <a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a1d473a6c6e1925e23503d6f1ed8a3557">ValidateAndRepairStateFinder</a> (<a class="el" href="../../d9/db9/classbool.html">bool</a> condition, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e1, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a> e2, <a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a> state)</td></tr>
<tr class="separator:a1d473a6c6e1925e23503d6f1ed8a3557"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a005969f642bf644c211097ef9c234859"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a005969f642bf644c211097ef9c234859">OnStoreLoad</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#a4ff67286551fc6c18504752a277c8bc1">ParamsReadContext</a> ctx, <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> version)</td></tr>
<tr class="memdesc:a005969f642bf644c211097ef9c234859"><td class="mdescLeft">&#160;</td><td class="mdescRight">load state of fsm  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a005969f642bf644c211097ef9c234859">More...</a><br /></td></tr>
<tr class="separator:a005969f642bf644c211097ef9c234859"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad87079cb47fdca803a4310aad08f95bc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ad87079cb47fdca803a4310aad08f95bc">GetCurrentStableStateID</a> ()</td></tr>
<tr class="separator:ad87079cb47fdca803a4310aad08f95bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2010ad60a87f54c0f43f0f63696ace6b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a2010ad60a87f54c0f43f0f63696ace6b">GetInternalStateID</a> ()</td></tr>
<tr class="separator:a2010ad60a87f54c0f43f0f63696ace6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adeff2d791ec8dcf75c7969b5901caa8e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#adeff2d791ec8dcf75c7969b5901caa8e">OnStoreSave</a> (<a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a> ctx)</td></tr>
<tr class="memdesc:adeff2d791ec8dcf75c7969b5901caa8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">save state of fsm  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#adeff2d791ec8dcf75c7969b5901caa8e">More...</a><br /></td></tr>
<tr class="separator:adeff2d791ec8dcf75c7969b5901caa8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cc92ee3a6b6a9da47f97db5d337aa5f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a4cc92ee3a6b6a9da47f97db5d337aa5f">RandomizeFSMState</a> (<a class="el" href="../../d9/db9/classbool.html">bool</a> hasBullet, <a class="el" href="../../d9/db9/classbool.html">bool</a> hasMagazine, <a class="el" href="../../d9/db9/classbool.html">bool</a> isJammed)</td></tr>
<tr class="memdesc:a4cc92ee3a6b6a9da47f97db5d337aa5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deprecated, use RandomizeFSMStateEx for better results.  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a4cc92ee3a6b6a9da47f97db5d337aa5f">More...</a><br /></td></tr>
<tr class="separator:a4cc92ee3a6b6a9da47f97db5d337aa5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2177109633c4bb7835df46abf888c610"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a2177109633c4bb7835df46abf888c610">RandomizeFSMStateEx</a> (<a class="el" href="../../d2/d41/classarray.html">array</a>&lt; <a class="el" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38">MuzzleState</a> &gt; muzzleStates, <a class="el" href="../../d9/db9/classbool.html">bool</a> hasMagazine, <a class="el" href="../../d9/db9/classbool.html">bool</a> isJammed)</td></tr>
<tr class="memdesc:a2177109633c4bb7835df46abf888c610"><td class="mdescLeft">&#160;</td><td class="mdescRight">With the parameters given, selects a random suitable state for the FSM of the weapon @NOTE: It is better to use Weapon_Base.RandomizeFSMState instead of calling this one @WARNING: Weapon_Base.Synchronize call might be needed, if this method is called while clients are connected.  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a2177109633c4bb7835df46abf888c610">More...</a><br /></td></tr>
<tr class="separator:a2177109633c4bb7835df46abf888c610"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-attribs" name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:afb03a16a1df86360c687a3fa1bc9985a"><td class="memItemLeft" align="right" valign="top">private <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#afb03a16a1df86360c687a3fa1bc9985a">m_SynchronizeAttempts</a></td></tr>
<tr class="separator:afb03a16a1df86360c687a3fa1bc9985a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a88db4c4ada7c3d0ddd538ab4cb6134"><td class="memItemLeft" align="right" valign="top">private <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a4a88db4c4ada7c3d0ddd538ab4cb6134">m_LastSynchronizeTime</a></td></tr>
<tr class="separator:a4a88db4c4ada7c3d0ddd538ab4cb6134"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa886ecac7af072a4cb3e2f3e3bc08d22"><td class="memItemLeft" align="right" valign="top">protected <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#aa886ecac7af072a4cb3e2f3e3bc08d22">m_NextStateId</a> = 0</td></tr>
<tr class="separator:aa886ecac7af072a4cb3e2f3e3bc08d22"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac978db76bb3834c3ff77d0574c1329aa"><td class="memItemLeft" align="right" valign="top">protected ref <a class="el" href="../../d2/d41/classarray.html">array</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ac978db76bb3834c3ff77d0574c1329aa">m_UniqueStates</a> = new <a class="el" href="../../d2/d41/classarray.html">array</a>&lt;<a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>&gt;</td></tr>
<tr class="memdesc:ac978db76bb3834c3ff77d0574c1329aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for InternalID: each state in a fsm is assigned an unique number  <a href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#ac978db76bb3834c3ff77d0574c1329aa">More...</a><br /></td></tr>
<tr class="separator:ac978db76bb3834c3ff77d0574c1329aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-static-attribs" name="pri-static-attribs"></a>
Static Private Attributes</h2></td></tr>
<tr class="memitem:aa30cfc2c78f8a0a45517792f4acdd48e"><td class="memItemLeft" align="right" valign="top">static private const <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#aa30cfc2c78f8a0a45517792f4acdd48e">MAX_SYNCHRONIZE_ATTEMPTS</a> = 12</td></tr>
<tr class="separator:aa30cfc2c78f8a0a45517792f4acdd48e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99d38d211257f51fc912036252e56889"><td class="memItemLeft" align="right" valign="top">static private const <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#a99d38d211257f51fc912036252e56889">MIN_SYNCHRONIZE_INTERVAL</a> = 3000</td></tr>
<tr class="separator:a99d38d211257f51fc912036252e56889"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff83827170f51b266307d1add59e2afc"><td class="memItemLeft" align="right" valign="top">static private const <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html#aff83827170f51b266307d1add59e2afc">RESET_SYNCHRONIZE_THRESHOLD</a> = 3600000</td></tr>
<tr class="separator:aff83827170f51b266307d1add59e2afc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock">
<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00004">4</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a39c6c17bbe295f0b340e09b9aa2e0370" name="a39c6c17bbe295f0b340e09b9aa2e0370"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a39c6c17bbe295f0b340e09b9aa2e0370">&#9670;&#160;</a></span>AddTransition()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::AddTransition </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>adds transition into transition table As a side effect registers the state(s) into m_UniqueStates </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00031">31</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="ac5e58979a0005f2a048074474b41a9e2" name="ac5e58979a0005f2a048074474b41a9e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac5e58979a0005f2a048074474b41a9e2">&#9670;&#160;</a></span>FindStableStateForID()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::FindStableStateForID </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>load from database - reverse lookup for state from saved id </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">id</td><td>the id stored in database during save </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00080">80</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="adbad6d95dace65d55f3737d8d773a806" name="adbad6d95dace65d55f3737d8d773a806"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adbad6d95dace65d55f3737d8d773a806">&#9670;&#160;</a></span>FindStateForInternalID()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::FindStateForInternalID </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>retrieve base state that matches given internal id </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">id</td><td>the id stored in database during save </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00064">64</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="ad87079cb47fdca803a4310aad08f95bc" name="ad87079cb47fdca803a4310aad08f95bc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad87079cb47fdca803a4310aad08f95bc">&#9670;&#160;</a></span>GetCurrentStableStateID()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::GetCurrentStableStateID </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00411">411</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a2010ad60a87f54c0f43f0f63696ace6b" name="a2010ad60a87f54c0f43f0f63696ace6b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2010ad60a87f54c0f43f0f63696ace6b">&#9670;&#160;</a></span>GetInternalStateID()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::GetInternalStateID </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00435">435</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a47c5052caf7a6925483e8748a3503a07" name="a47c5052caf7a6925483e8748a3503a07"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a47c5052caf7a6925483e8748a3503a07">&#9670;&#160;</a></span>Internal_ValidateAndRepair()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::Internal_ValidateAndRepair </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>validate the state of the gun and repair if mismatch </p>
<dl class="section return"><dt>Returns</dt><dd>bool whether it performed repairing or not </dd></dl>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00216">216</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a3033531843a746d7181e7e167df5f6dc" name="a3033531843a746d7181e7e167df5f6dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3033531843a746d7181e7e167df5f6dc">&#9670;&#160;</a></span>LoadAndSetCurrentFSMState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected <a class="el" href="../../d9/db9/classbool.html">bool</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::LoadAndSetCurrentFSMState </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#a4ff67286551fc6c18504752a277c8bc1">ParamsReadContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td>
          <td class="paramname"><em>version</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00096">96</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a7764df4dff05076f74167b0ce50bdc43" name="a7764df4dff05076f74167b0ce50bdc43"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7764df4dff05076f74167b0ce50bdc43">&#9670;&#160;</a></span>LoadCurrentFSMState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::LoadCurrentFSMState </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#a4ff67286551fc6c18504752a277c8bc1">ParamsReadContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td>
          <td class="paramname"><em>version</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>load current state of fsm </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00123">123</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a007b947e912d1e84eca73d5c8bd45901" name="a007b947e912d1e84eca73d5c8bd45901"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a007b947e912d1e84eca73d5c8bd45901">&#9670;&#160;</a></span>LoadCurrentUnstableFSMState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d9/db9/classbool.html">bool</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::LoadCurrentUnstableFSMState </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td>
          <td class="paramname"><em>version</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00134">134</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a6cb72d561154285bebee4d88f7041b5d" name="a6cb72d561154285bebee4d88f7041b5d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6cb72d561154285bebee4d88f7041b5d">&#9670;&#160;</a></span>OnFailThresholdBreached()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected void <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::OnFailThresholdBreached </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../db/de5/class_weapon.html">Weapon</a>&#160;</td>
          <td class="paramname"><em>weapon</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d5/da2/group___strings.html#d5/d92/classstring">string</a>&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>stateCondition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>gunCondition</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00354">354</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a005969f642bf644c211097ef9c234859" name="a005969f642bf644c211097ef9c234859"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a005969f642bf644c211097ef9c234859">&#9670;&#160;</a></span>OnStoreLoad()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::OnStoreLoad </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#a4ff67286551fc6c18504752a277c8bc1">ParamsReadContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a>&#160;</td>
          <td class="paramname"><em>version</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>load state of fsm </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00381">381</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="adeff2d791ec8dcf75c7969b5901caa8e" name="adeff2d791ec8dcf75c7969b5901caa8e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adeff2d791ec8dcf75c7969b5901caa8e">&#9670;&#160;</a></span>OnStoreSave()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::OnStoreSave </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>save state of fsm </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00447">447</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a121dc2e835caf00f21e1150f7e03983b" name="a121dc2e835caf00f21e1150f7e03983b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a121dc2e835caf00f21e1150f7e03983b">&#9670;&#160;</a></span>ProcessAbortEvent()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">override <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::ProcessAbortEvent </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">out <a class="el" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a>&#160;</td>
          <td class="paramname"><em>result</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00046">46</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="aff48945f386ea092ea49ec243f5f1796" name="aff48945f386ea092ea49ec243f5f1796"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff48945f386ea092ea49ec243f5f1796">&#9670;&#160;</a></span>ProcessAbortTransition()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">override protected <a class="el" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::ProcessAbortTransition </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00053">53</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a81eb0c468b2fe3a4fe62441b3f47f8e0" name="a81eb0c468b2fe3a4fe62441b3f47f8e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a81eb0c468b2fe3a4fe62441b3f47f8e0">&#9670;&#160;</a></span>ProcessLocalTransition()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">override protected <a class="el" href="../../da/d51/_f_s_m_base_8c.html#a09f6ec45b8f9309647a7b1eb893bc29f">ProcessEventResult</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::ProcessLocalTransition </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#d8/d41/class_f_s_m_transition">FSMTransition</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00039">39</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a4cc92ee3a6b6a9da47f97db5d337aa5f" name="a4cc92ee3a6b6a9da47f97db5d337aa5f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4cc92ee3a6b6a9da47f97db5d337aa5f">&#9670;&#160;</a></span>RandomizeFSMState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::RandomizeFSMState </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>hasBullet</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>hasMagazine</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>isJammed</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Deprecated, use RandomizeFSMStateEx for better results. </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00457">457</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a2177109633c4bb7835df46abf888c610" name="a2177109633c4bb7835df46abf888c610"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2177109633c4bb7835df46abf888c610">&#9670;&#160;</a></span>RandomizeFSMStateEx()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::RandomizeFSMStateEx </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/d41/classarray.html">array</a>&lt; <a class="el" href="../../d8/d8f/_weapon_stable_state_8c.html#a81850a19579d69fbd62d39a8f08a5f38">MuzzleState</a> &gt;&#160;</td>
          <td class="paramname"><em>muzzleStates</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>hasMagazine</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>isJammed</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>With the parameters given, selects a random suitable state for the FSM of the weapon @NOTE: It is better to use Weapon_Base.RandomizeFSMState instead of calling this one @WARNING: Weapon_Base.Synchronize call might be needed, if this method is called while clients are connected. </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00473">473</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a547396c4dcbe758656386371d79b4163" name="a547396c4dcbe758656386371d79b4163"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a547396c4dcbe758656386371d79b4163">&#9670;&#160;</a></span>SaveCurrentFSMState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::SaveCurrentFSMState </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>save current state of fsm </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00154">154</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a2b9c22cee987009d8b509d91d72371a1" name="a2b9c22cee987009d8b509d91d72371a1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2b9c22cee987009d8b509d91d72371a1">&#9670;&#160;</a></span>SaveCurrentUnstableFSMState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d9/db9/classbool.html">bool</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::SaveCurrentUnstableFSMState </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d8/d18/gameplay_8c.html#af1d1033fca2ebd02f4ba61051b6341c4">ParamsWriteContext</a>&#160;</td>
          <td class="paramname"><em>ctx</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00175">175</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a0a6d548e39e2404b64acd5411b09caba" name="a0a6d548e39e2404b64acd5411b09caba"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0a6d548e39e2404b64acd5411b09caba">&#9670;&#160;</a></span>SetInternalID()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected void <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::SetInternalID </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>&#160;</td>
          <td class="paramname"><em>state</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>unique list of states in this machine (automation of save/load) </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00015">15</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="ae7d3938684ce733ea27a97ab89ef2ed9" name="ae7d3938684ce733ea27a97ab89ef2ed9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae7d3938684ce733ea27a97ab89ef2ed9">&#9670;&#160;</a></span>ValidateAndRepair()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::ValidateAndRepair </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>validate the state of the gun and repair if mismatch </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00207">207</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a8e24e0c05a0b315f2b16c1feb4c9d3f4" name="a8e24e0c05a0b315f2b16c1feb4c9d3f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e24e0c05a0b315f2b16c1feb4c9d3f4">&#9670;&#160;</a></span>ValidateAndRepairHelper()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected <a class="el" href="../../d9/db9/classbool.html">bool</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::ValidateAndRepairHelper </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d3/d9c/class_weapon___base.html">Weapon_Base</a>&#160;</td>
          <td class="paramname"><em>weapon</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d5/da2/group___strings.html#d5/d92/classstring">string</a>&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>stateCondition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>gunCondition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">out <a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a>&#160;</td>
          <td class="paramname"><em>state</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00287">287</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a1d473a6c6e1925e23503d6f1ed8a3557" name="a1d473a6c6e1925e23503d6f1ed8a3557"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1d473a6c6e1925e23503d6f1ed8a3557">&#9670;&#160;</a></span>ValidateAndRepairStateFinder()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected <a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::ValidateAndRepairStateFinder </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d9/db9/classbool.html">bool</a>&#160;</td>
          <td class="paramname"><em>condition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>&#160;</td>
          <td class="paramname"><em>e2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../dc/dcc/class_weapon_stable_state.html">WeaponStableState</a>&#160;</td>
          <td class="paramname"><em>state</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00366">366</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<h2 class="groupheader">Field Documentation</h2>
<a id="a4a88db4c4ada7c3d0ddd538ab4cb6134" name="a4a88db4c4ada7c3d0ddd538ab4cb6134"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4a88db4c4ada7c3d0ddd538ab4cb6134">&#9670;&#160;</a></span>m_LastSynchronizeTime</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">private <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::m_LastSynchronizeTime</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00010">10</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="aa886ecac7af072a4cb3e2f3e3bc08d22" name="aa886ecac7af072a4cb3e2f3e3bc08d22"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa886ecac7af072a4cb3e2f3e3bc08d22">&#9670;&#160;</a></span>m_NextStateId</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::m_NextStateId = 0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00012">12</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="afb03a16a1df86360c687a3fa1bc9985a" name="afb03a16a1df86360c687a3fa1bc9985a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb03a16a1df86360c687a3fa1bc9985a">&#9670;&#160;</a></span>m_SynchronizeAttempts</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">private <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::m_SynchronizeAttempts</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00009">9</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="ac978db76bb3834c3ff77d0574c1329aa" name="ac978db76bb3834c3ff77d0574c1329aa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac978db76bb3834c3ff77d0574c1329aa">&#9670;&#160;</a></span>m_UniqueStates</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">protected ref <a class="el" href="../../d2/d41/classarray.html">array</a>&lt;<a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>&gt; <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::m_UniqueStates = new <a class="el" href="../../d2/d41/classarray.html">array</a>&lt;<a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>&gt;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>counter for InternalID: each state in a fsm is assigned an unique number </p>

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00013">13</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="aa30cfc2c78f8a0a45517792f4acdd48e" name="aa30cfc2c78f8a0a45517792f4acdd48e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa30cfc2c78f8a0a45517792f4acdd48e">&#9670;&#160;</a></span>MAX_SYNCHRONIZE_ATTEMPTS</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">private const <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::MAX_SYNCHRONIZE_ATTEMPTS = 12</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00006">6</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="a99d38d211257f51fc912036252e56889" name="a99d38d211257f51fc912036252e56889"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99d38d211257f51fc912036252e56889">&#9670;&#160;</a></span>MIN_SYNCHRONIZE_INTERVAL</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">private const <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::MIN_SYNCHRONIZE_INTERVAL = 3000</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00007">7</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<a id="aff83827170f51b266307d1add59e2afc" name="aff83827170f51b266307d1add59e2afc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff83827170f51b266307d1add59e2afc">&#9670;&#160;</a></span>RESET_SYNCHRONIZE_THRESHOLD</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">private const <a class="el" href="../../d5/dc2/_cache_object_8c.html#a2dd3d4ba19a58e86cd16f281a6b82c8e">int</a> <a class="el" href="../../d0/deb/namespace_3global_scope_4.html#dd/d73/class_h_f_s_m_base">HFSMBase</a>&lt; <a class="el" href="../../d2/db4/class_weapon_state_base.html">WeaponStateBase</a>, <a class="el" href="../../d7/db7/class_weapon_event_base.html">WeaponEventBase</a>, <a class="el" href="../../d3/ddb/class_weapon_action_base.html">WeaponActionBase</a>, <a class="el" href="../../dc/d3f/class_weapon_guard_base.html">WeaponGuardBase</a> &gt;::RESET_SYNCHRONIZE_THRESHOLD = 3600000</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html#l00008">8</a> of file <a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>scripts/4_World/Entities/Firearms/<a class="el" href="../../dd/d89/_weapon_f_s_m_8c_source.html">WeaponFSM.c</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../d2/d15/class_h_f_s_m_base_3_01_weapon_state_base_00_01_weapon_event_base_00_01_weapon_action_base_00_01_weapon_guard_base_01_4.html">HFSMBase&lt; WeaponStateBase, WeaponEventBase, WeaponActionBase, WeaponGuardBase &gt;</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
